<?php

/*
    MyBlitzortung - a tool for participants of blitzortung.org
	to display lightning data on their web sites.

    Copyright (C) 2011  Tobias Volgnandt

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/*******************************************************************/
/* IMPORTANT: DO NOT EDIT THIS FILE!                               */
/* Use config.php for individual setting!                          */
/* Copy the desired line, without the trailing @                   */
/*                                                                 */
/* Info: This file is included AFTER config.php                    */
/*******************************************************************/




/*******************************************************************/
/*** Your Region                                                 ***/
/*     1 = Europe                                                  */
/*     2 = Oceania                                                 */
/*     3 = North America                                           */
/*     4 = Japan                                                   */

@define('BO_REGION', 1);




/*** Main file for creating graphs and images (URL!).            ***/
/*   You can use relative or absolute (with leading "/") paths:    */
/*   Only "blitzortung.php" should be ok in most cases.            */
/*   You can also use http://.../blitzortung.php                   */
/*                                                                 */
/*   Example: http://myhomepage.com/strikes/blitzortung.php        */
/*             ==> BO_FILE = "/strikes/blitzortung.php"            */

@define('BO_FILE', 'blitzortung.php');


/*** No-cookie URL                                                 */
/*   For faster retrieving of tiles and images                     */
/*   Enter complete URL with http://...                            */
/*                                                                 */
/*   Example: http://nocookie.domain.com/path/blitzortung.php       */

@define('BO_FILE_NOCOOKIE', '');



/*******************************************************************/
/*** UTF8-Encoding                                               ***/
/*   Most Content-Management-Systems use UTF8-encoding.            */
/*   Set it to false, when including with php into your            */
/*   own page and wrong characters appear                          */

@define('BO_UTF8', true);


//if strings in your config.php are utf8-encoded, set to true
//Note: You have to encode all non-utf strings in templates by yourself
//This is only a workaround for later versions,
//as saving utf in php files isn't a good idea at all
@define('BO_CONFIG_IS_UTF8', false);


/*******************************************************************/
/*** Update secret                                               ***/

@define('BO_UPDATE_SECRET', '');



/*******************************************************************/
/*** Default Port for MySQL                                      ***/

@define('BO_DB_PORT', null);



/*******************************************************************/
/*** Number of Antennas of your Station                          ***/
/*** only "1" or "2" is possible !                               ***/

@define('BO_ANTENNAS', 2);


/*******************************************************************/
/*** Some general important stuff                                ***/


//Default timezone
@define('BO_TIMEZONE', 'UTC');

//Show timezone in every time
@define('BO_SHOW_TIMEZONE', false);

//Use miles
@define('BO_IMPERIAL', false);


/*******************************************************************/
/*** Copyright footer                                            ***/
/*** your own copyright/web-address in images/graphs/footer      ***/

//Text, i.e. 'MyWeatherSite www.example.com'
@define('BO_OWN_COPYRIGHT', '');

//Textsize for graphs
@define('BO_OWN_COPYRIGHT_SIZE', 7);

//Text for graphs
@define('BO_OWN_COPYRIGHT_GRAPHS', ''); //empty string -> use above / false -> disable

//Text for maps
@define('BO_OWN_COPYRIGHT_MAPS', ''); //empty string -> use above / false -> disable


/*******************************************************************/
/*** Update intervals (Minutes!)                                 ***/

//strikes update interval
@define('BO_UP_INTVL_STRIKES', 1);

//stations update interval
@define('BO_UP_INTVL_STATIONS', 15);

//min interval of external downloads
@define('BO_UP_INTVL_DOWNLOADS', 1);


/*******************************************************************/
/*** Update intervals (Minutes!)                                 ***/

//max age of a stroke
@define('BO_UP_STROKE_MIN_TIME', "now -48 hours");


/*******************************************************************/
/*** Language settings                                           ***/

//main locale
@define('BO_LOCALE', 'en');

//shows translation in this language, if main language doesn't exist ('en' if nothing is set)
@define('BO_LOCALE2', '');

//available locales
@define('BO_LANGUAGES', 'en,de,fr,it,hu,nl,lv,fi,sv,pl,cz,dk,uk,sk');

//show links in the footer
@define('BO_SHOW_LANGUAGES', true);

//show flags
@define('BO_SHOW_LANG_FLAGS', true);

//force selectable languages (BO_LANGUAGES)
//otherwise changing the language with "&bo_lang=xx" in URL would be possible
@define('BO_FORCE_LANGS', false);

//force default language in maps (true)
//otherwise an extra map for each language will be generated and saved in cache!
@define('BO_FORCE_MAP_LANG', true);

//same as above for graphs
@define('BO_FORCE_GRAPH_LANG', false);

//translate single words that which are longer than given length
@define('BO_TRANSLATE_SINGLE_WORDS', 0);

//redirect so that always the correct "bo_lang=xx" in URL
@define('BO_LANG_REDIRECT', false);



/*******************************************************************/
/*** User / Login                                                ***/

//show the login link at the bottom
@define('BO_LOGIN_SHOW', true);

//allow login to
@define('BO_LOGIN_ALLOW', 2); //0=nobody, 1=you, 2=all

// days where automatic login cookie is valid. set to false to disable auto login
@define('BO_LOGIN_COOKIE_TIME', 60);



/*******************************************************************/
/*** Session handling                                            ***/

//name of session
//leave blank, then default PHP (i.e. PHPSESSID)
@define('BO_SESSION_NAME', '');

//default path of session cookie
@define('BO_SESSION_COOKIE_PATH', '/');

//lifetime of session cookie (seconds)
@define('BO_SESSION_COOKIE_LIFETIME', 3600 * 24);

//close sessions before output
//so the browser use more that one concurrent connection at once
//hint: set it to 0 or 1 if you have problems
//0: never close (let php do it)
//1: late
//2: early
@define('BO_SESSION_CLOSE', 2);

//Starts session only if there's a special GET parameter
@define('BO_SESSION_GET_PARAM', false);

//Starts session only if there's a special COOKIE parameter
@define('BO_SESSION_COOKIE_PARAM', false);

//Cookie name of saved login data
@define("BO_COOKIE_NAME", "bo_login");



/*******************************************************************/
/*** Warn with email if station/tracker sends no signals         ***/

//Warnings enabled?
@define('BO_TRACKER_WARN_ENABLED', false);

//Warn after given when no signals were send (plus 60 minutes due to stations.txt statistics)
@define('BO_TRACKER_WARN_AFTER_HOURS', 1);

//resent warning after given hours if problem persists
@define('BO_TRACKER_WARN_RESEND_HOURS', 12);



/*******************************************************************/
/*** Import error handling                                       ***/

// min count, error occured (0 disables reporting)
@define('BO_UP_ERR_MIN_COUNT',   1);

// time in minutes in which the error occurs
@define('BO_UP_ERR_MIN_MINUTES', 30);

// if error persits, send mail max. every defined minutes
@define('BO_UP_ERR_SEND_INTERVAL', 720);

// if new station count is too low -> don't read new data
@define('BO_UP_STATION_DIFFER', 0.95);




/*******************************************************************/
/*** Enable automatic rewriting of status files                  ***/
/*** See /status/status.cfg for more information                 ***/

@define('BO_ENABLE_STATUS_FILES', false);



/*******************************************************************/
/*** URLs                                                        ***/
/*   These have only to be changed if you use the PHP include      */
/*   feature. The URLs should end with an "?" if they have no      */
/*   query                                                         */

@define('BO_MAP_URL', 'index.php?bo_page=map');
@define('BO_ARCHIVE_URL', 'index.php?bo_page=archive');
@define('BO_STATISTICS_URL', 'index.php?bo_page=statistics');
@define('BO_INFO_URL', 'index.php?bo_page=info');
@define('BO_LOGIN_URL', 'index.php?bo_page=login');





/*******************************************************************/
/*** The file cache                                              ***/

//when true, disables caching of maps and map tiles (you should leave it on false!)
@define('BO_CACHE_DISABLE', false);

//create subdirs for faster access (may not work with php safemode ON)
@define('BO_CACHE_SUBDIRS', true);

//cache dir
@define('BO_CACHE_DIR', 'cache');

//enable data caching
@define('BO_CACHE_DATA', true);

//purges tiles when older that specified value (hours)
@define('BO_CACHE_PURGE_TILES_HOURS', 24);

//how often the purge should start (0 = never, 1 = every call, 2 = ever 2nd call...)
@define('BO_CACHE_PURGE_TILES_RAND',  1000);

//purges maps when older that specified value (hours)
@define('BO_CACHE_PURGE_MAPS_HOURS', 24 * 4);

//how often the purge should start (0 = never, 1 = every call, 2 = ever 2nd call...)
@define('BO_CACHE_PURGE_MAPS_RAND',  1000);

//purges density maps when older that specified value (hours)
@define('BO_CACHE_PURGE_DENS_HOURS', 24 * 10);

//how often the purge should start (0 = never, 1 = every call, 2 = ever 2nd call...)
@define('BO_CACHE_PURGE_DENS_RAND',  1000);

//purges other files when older that specified value (hours)
@define('BO_CACHE_PURGE_OTHER_HOURS', 24);

//how often the purge should start (0 = never, 1 = every call, 2 = ever 2nd call...)
@define('BO_CACHE_PURGE_OTHER_RAND',  100);

//try not to use the database
//enable for server with high load
@define('BO_CACHE_FAST', false);

// if file is outdated, check the last update time first
// if it was before last file-mod time, then set file-mod
// to now + (update-interval / divisor)
// so the file will be valid again for some time
@define('BO_CACHE_MOD_UPDATE_DIVISOR', false);

//wait given milliseconds if same file is currently processed by another client
//set 0 or false to disable
@define('BO_CACHE_WAIT_SAME_FILE', false);

//if option above is enabled and the wait timeout is exeeded, then
//output old file from cache to the client, if it's still newer
//than given multiplicated with specific update interval
//example: given: file is 4min old, update interval is 2min, default value from below used
//          => 2min*3 = 6min  =>  4min is smaller than 6min
//          => old file will be served to the client instead of creating a new one
//factor can be a decimal value (i.e. 1.4)
@define('BO_CACHE_WAIT_SAME_FILE_OLD', 3);

//deliver old cache file while creating a new one
//user will get a new file without to wait
//value is factor for the update interval, in which the old file will still be delivered
//factor can be a decimal value (i.e. 1.4)
//if file is older, then it will be created new
//set 0 or false to disable
@define('BO_CACHE_CREATE_NEW_DELIVER_OLD', 0);

//Log cache info in cache/cache.log
@define('BO_CACHE_LOG', false);

//send cache-control headers to browser for HTML pages
//set to a value in seconds
//i.e. 60 means, the html page should be held in cache for 1 minute by the browser
//set to the minimum update interval (BO_UP_INTVL_STRIKES is 5 --> set to 300)
//set 0 or false to disable
@define('BO_SEND_CACHE_HEADER_HTML', false);




/*******************************************************************/
/*** Statistics                                                  ***/

//Disables statistics for guests
@define('BO_DISABLE_STATISTICS_GUESTS', false);


// Show GPS Info
// You can set your BO_LAT, BO_LON to rough coordinates and
// disable this option. So nobody can see your exact position.
@define('BO_SHOW_GPS_INFO', true);


// Map type for GPS info
@define('BO_STATISTICS_GPS_MAPTYPE', 'HYBRID');


// Map type for GPS info
// 0 => fit into window
@define('BO_STATISTICS_GPS_MAP_ZOOM', 17);


// Disable station statistics (needs database and cpu power!)
@define('BO_STATION_STAT_DISABLE', true);


// Mark stations offline after specified time with no activity
@define('BO_STATION_OFFLINE_MINUTES', 20);


// Minutes, after which stations marked as not available when not present in stations export file
@define('BO_STATION_NOT_PRESENT_MINUTES', 22);


// Mark stations as not available when no signals have been sent
@define('BO_STATION_INACTIVE_DAYS', 365);


// Show new stations
@define('BO_STATISTICS_SHOW_NEW_STATIONS', 0);


// Statistics for all station
@define('BO_STATISTICS_ALL_STATIONS', 0); // 0 = disable, 1 = with specific link, 2 = links from table for everyone


// Map type for station-statistic page
@define('BO_STATISTICS_STATION_MAPTYPE', 'HYBRID');


// Default order of stations table
// possible values: country,city,strikes,signals,signals_ratio,efficiency,distance
@define('BO_STATISTICS_STATIONS_SORT', 'distance');


//Time-ranges for network statistics (1h is always present)
@define('BO_STATISTICS_NETWORK_RANGES', ''); //hours, comma separated


//Pre defined distances for region select box
@define('BO_DISTANCES_REGION', '10, 25, 50, 100, 200, 300, 400, 500, 750, 1000, 1500, 2000, 3000');


//Update "offline hours counter" only if station was online some time before (hours)
@define('BO_STATISTICS_COUNT_OFFLINE_AFTER_MIN_ONLINE_HOURS', 96);



/*******************************************************************/
/*** Image Maps: General settings                                ***/

// order your maps, comma separated ids like "4,2,12,34,2,0"
@define('BO_MAPS_ORDER', '');

//use true color images for internal drawing
//gives nicer transparency effects - higer CPU usage and bigger files size
@define('BO_IMAGE_USE_TRUECOLOR', true);

//use truecolor images for drawing transparent images
@define('BO_IMAGE_USE_TRUECOLOR_TRANSPARENT', false);

//use palette images for MAPS with defined colors for output (0 disables)
// --> reduces colors to defined for smaller file sizes
// may cause some problems with colors on different images!!!
@define('BO_IMAGE_PALETTE_COLORS_MAPS', 256);

//use palette images for DENSITY MAPS with defined colors for output (0 disables)
// --> reduces colors to defined for smaller file sizes
@define('BO_IMAGE_PALETTE_COLORS_DENSITIES', 0);

//use palette images for TRANSPARENT MAPS with defined colors for output (0 disables)
// --> reduces colors to defined for smaller file sizes
@define('BO_IMAGE_PALETTE_COLORS_TRANSPARENT', 0);

//automatically use true color if colorcount in palette image is above 256
//set BO_IMAGE_PALETTE_COLORS_MAPS to 256
//you will automatically get the smallest file, but also truecolor images when needed
@define('BO_IMAGE_PALETTE_AUTO', true);

//PNG compression: the highter the slower!!!
@define('BO_IMAGE_PNG_COMPRESSION', 7);

//Set it to PNG_ALL_FILTERS for better compression (doesn't seem to make any difference)
@define('BO_IMAGE_PNG_FILTERS', PNG_NO_FILTER);

//Jpeg Quality 100 = best
@define('BO_IMAGE_JPEG_QUALITY', 90);

// automatic update off by default
@define('BO_MAPS_AUTOUPDATE_DEFAULTON', true);

//archived images: when should the image expire
@define('BO_MAPS_ARCHIVE_EXPIRE_SEC', 3600);




/*******************************************************************/
/*** Fonts: General settings                                     ***/

// normal truetype font file
@define('BO_FONT_TTF_NORMAL', 'fonts/DejaVuSans.ttf');

// normal bold font file
@define('BO_FONT_TTF_BOLD', 'fonts/DejaVuSans-Bold.ttf');

// mono truetype font file
@define('BO_FONT_TTF_MONO', 'fonts/DejaVuSansMono.ttf');

// set to false if fonts in pictures do not work
@define('BO_FONT_USE_FREETYPE2', true);



/*******************************************************************/
/*** Dynamic Map: General settings                               ***/
/*   Appearance of the dynamic map, colors, icons etc.             */

/*** WARNING ***/
/*** Do not raise the following two values,                      ***/
/*** otherwise autolinking will not work!                        ***/

// (kilometers) limits strike display to radius around station
@define('BO_RADIUS', 50);

// (kilometers) radius for statistics
@define('BO_RADIUS_STAT', 50);

// when zoom reaches this level, strike display is limited to max. distance around station (BO_RADIUS)
@define('BO_MAX_ZOOM_LIMIT', 8);

//Completely disable the dynamic map
@define('BO_MAP_DISABLE', false);

// default zoom level
@define('BO_DEFAULT_ZOOM', 7);

// default zoom level for archive
@define('BO_DEFAULT_ZOOM_ARCHIVE', 10);

// max. zoom level for guest, even in the area of your station
@define('BO_MAX_ZOOM_IN', 12);

// minimal zoom level for guests
@define('BO_MIN_ZOOM_OUT', 4);

// max. zoom level for users
@define('BO_MAX_ZOOM_IN_USER', 14);

// minimal zoom level for users
@define('BO_MIN_ZOOM_OUT_USER', 2);

// the default map style (you can also use satellite, hybrid, street)
@define('BO_DEFAULT_MAP', 'TERRAIN');

// if you want another lat,lon for your radius area
@define('BO_MAP_LAT', 0);
@define('BO_MAP_LON', 0);

//some default colors and sizes
@define('BO_MAP_CIRCLE_COLOR_LINE', '#FF0000');
@define('BO_MAP_CIRCLE_OPAC_LINE', '0.8');
@define('BO_MAP_CIRCLE_STROKE_LINE', 1);
@define('BO_MAP_CIRCLE_COLOR_FILL', '#FF0000');
@define('BO_MAP_CIRCLE_OPAC_FILL', '0.05');
@define('BO_MAP_CIRCLE_SHOW_ZOOM', 0);


//displaying of strikes
@define('BO_MAP_STRIKE_SHOW_CIRCLE_ZOOM', 7);
@define('BO_MAP_STRIKE_SHOW_DEVIATION_ZOOM', 12);
@define('BO_MAP_STRIKE_SHOW_TEXT', 16);
@define('BO_MAP_STRIKE_SIZE', 3);
@define('BO_MAP_STRIKE_CIRCLE_SIZE', 4);
@define('BO_MAP_STRIKE_CIRCLE_GROW', 0.6);
@define('BO_MAP_MAX_STRIKES_PER_TILE', 50000);

//some other values, sizes etc...
@define('BO_MAP_STATION_ICON', '//labs.google.com/ridefinder/images/mm_20_red.png');
@define('BO_MAP_STATION_ICON2', '//labs.google.com/ridefinder/images/mm_20_green.png');
@define('BO_MAP_LEGEND_WIDTH', 80);
@define('BO_MAP_LEGEND_HEIGHT', 10); //only colorbar
@define('BO_MAP_LEGEND_FONTSIZE', 2); //no TTF!
@define('BO_MAP_NA_FONTSIZE', 9); 
@define('BO_MAP_COUNT_FONTSIZE', 8);
@define('BO_MAP_COUNT_FONTBOLD', true);
@define('BO_MAP_COUNT_STATIONS', 15);

//Manual time ranges
@define('BO_MAP_MANUAL_TIME_ENABLE', false); //enables for guests
@define('BO_MAP_MANUAL_TIME_MAX_HOURS', 6); //max. hours between start and end (YOU can always access as much as you want - be careful!)

//MyBlitzortung Stations display
@define('BO_MAP_MYBO_CIRCLE_COLOR_LINE', '#0000FF');
@define('BO_MAP_MYBO_CIRCLE_OPAC_LINE', '0.8');
@define('BO_MAP_MYBO_CIRCLE_COLOR_FILL', '#0000FF');
@define('BO_MAP_MYBO_CIRCLE_OPAC_FILL', '0.05');
@define('BO_MAP_MYBO_ICON', '//labs.google.com/ridefinder/images/mm_20_blue.png');

//Version of Google Maps API
@define('BO_GMAP_API_VERSION', '3.15');

//Google Maps additional parameters
// - API Key: &key={key}
// - Sensor: &sensor={false|true}  <-- must be included!
@define('BO_GMAP_PARAM', 'sensor=false');

//Allow selection of stations
@define('BO_MAP_STATION_SELECT', false);

//Show clouds
@define('BO_MAP_SHOW_CLOUDS', false);

//Show mouse coordinates
@define('BO_MAP_SHOW_COORD', false);

//Show search field
@define('BO_MAP_SHOW_SEARCH', false);


//reloads whole map page when user didn't make any activities
//and is active again after defined interval (minutes)
//good when you use visitor counters
@define('BO_MAP_PAGE_RELOAD_INACTIVITY', 0);

//Allow auto update
//set to a value in minutes,
//then auto update ends when user didn't make any activities
//set to a very high value like 99999999 to "disable" auto-end
@define('BO_MAP_AUTOUPDATE', 99999999);

//set to true, to enable autoupdate by default
@define('BO_MAP_AUTOUPDATE_DEFAULT_ON', false);

//displays message if autoupdate ends due to timeout
@define('BO_MAP_AUTOUPDATE_STALL_MSG', true);

//reload whole page after autoupdate-stalled message
@define('BO_MAP_AUTOUPDATE_STALL_RELOAD', false);



/*******************************************************************/
/*** Calculate tracks                                            ***/
/*   WARNING: This is currently very expermintal.                  */
/*   It may slow down your server!                                 */


//scan time in minutes (set to 0 to disable tracks)
@define('BO_TRACKS_SCANTIME', 0);

//update tracks every x minutes
@define('BO_UP_INTVL_TRACKS', 5);

//divide the scantime into given intervals (minimum 2 for tracks)
@define('BO_TRACKS_DIVISOR',  2);

//kilometers
@define('BO_TRACKS_RADIUS_SEARCH_STRIKES', 10);
@define('BO_TRACKS_RADIUS_SEARCH_NGBR_CELLS', 30);
@define('BO_TRACKS_RADIUS_SEARCH_OLD_CELLS', 30);

//display of cells/tracks
@define('BO_TRACKS_MAP_OPACITY', 0.7);
@define('BO_TRACKS_MAP_ZOOM_MIN', 6);
@define('BO_TRACKS_MAP_ZOOM_MAX', 10);
@define('BO_TRACKS_MAP_ZOOM_INFO', 7);
@define('BO_TRACKS_MAP_TIME_FORCAST', 60);
@define('BO_TRACKS_MAP_MIN_STRIKES_DISPLAY', 10);
@define('BO_TRACKS_SHOW_UNTRACKED', false);

//Min/max strokes
@define('BO_TRACKS_MIN_STRIKE_COUNT', 15);
@define('BO_TRACKS_MAX_STRIKE_COUNT', 1000);



/*******************************************************************/
/*** Archive                                                     ***/

//Completely disables archive
@define('BO_DISABLE_ARCHIVE', false);

//Enables archive (maps by date and animations) for guests
@define('BO_ENABLE_ARCHIVE_MAPS', false);

//Enables densities for guests (set the also BO_CALC_DENSITIES option to true)
@define('BO_ENABLE_DENSITIES', false);

//Enables strike search
@define('BO_ENABLE_ARCHIVE_SEARCH', true);

//Enable signal page
@define('BO_ENABLE_ARCHIVE_SIGNALS', true);

//Calculates Densities
@define('BO_CALC_DENSITIES', false);

//Calculates Densities for current year/month
@define('BO_CALC_DENSITIES_CURRENT', true);

//Calculates Densities for current year/month also for other stations than yours
@define('BO_CALC_DENSITIES_CURRENT_ALL', false);

//Calculates Densities for given stations ids, separated by comma
//otherwise only general densitiy and your densitiy will be calculated
//set to 'all' to calculate for all stations
@define('BO_DENSITY_STATIONS', '');

//When displaying densities, group max values (higher =>more grouping, 0=no)
@define('BO_DENSITIES_GROUP_MAX', 30);

//maximum no. of strikes displayed when searching for them
@define('BO_ARCHIVE_SEARCH_STRIKECOUNT', 10);

//default radius for strike search in kilometers
@define('BO_ARCHIVE_SEARCH_RADIUS_DEFAULT', 10);

//max radius for strike search in kilometers
@define('BO_ARCHIVE_SEARCH_RADIUS_MAX', 50);

//show the spectrum for each signal in table
@define('BO_ARCHIVE_SHOW_SPECTRUM', true);

//show the xy plot for each signal in table
@define('BO_ARCHIVE_SHOW_XY', true);

//try to find and show first signal to a stroke when no station selected
@define('BO_ARCHIVE_SHOW_FIRST_SIGNAL', true);

//entries in strike table per page
@define('BO_ARCHIVE_TABLE_PER_PAGE', 10);


//Strike details
@define('BO_ARCHIVE_STR_DETAILS_LINECOLOR', '6f64');
@define('BO_ARCHIVE_STR_DETAILS_LINECOLOR_NOCALC', 'fa09');
@define('BO_ARCHIVE_STR_DETAILS_DEFAULT_POINT', 'stations_strikedetails');
@define('BO_ARCHIVE_STR_DETAILS_DEFAULT_POINT_STATION_CALC', 'stations_strikedetails_calc');
@define('BO_ARCHIVE_STR_DETAILS_HYPCOLOR', 'f7f7');
@define('BO_ARCHIVE_STR_DETAILS_STATION_COUNT_CALC', 4);

//Static map
@define('BO_SMAP_MAX_RANGE', 24);  //Maximum time range bewteen start and end time (hours)
@define('BO_SMAP_MIN_RANGE', 15);  //Maximum time range bewteen start and end time (minutes)
@define('BO_SMAP_RANGE_STEP', 6);  //Step time in select box (hours)

//Animations (not the gif-animations!)
@define('BO_ANIMATIONS_INTERVAL', 15); //Time in minutes between two frames - 0 disables animations
@define('BO_ANIMATIONS_STRIKE_TIME', 120); //Time range of displayed strikes per frame
@define('BO_ANIMATIONS_DEFAULT_RANGE', 2);  //Default time range bewteen start and end time (hours)
@define('BO_ANIMATIONS_MAX_RANGE', 24);  //Maximum time range bewteen start and end time (hours)
@define('BO_ANIMATIONS_WAITTIME', 100); //Wait time between frames during animation (milliseconds)
@define('BO_ANIMATIONS_WAITTIME_END', 1000); //Wait at the and of a loop (milliseconds)
@define('BO_ANIMATIONS_RANGE_STEP', 1);  //Step time in select box (hours)

//Animation of the strike locating, default count of pics (0 = disable)
@define('BO_ARCHIVE_STRIKE_INFO_ANIM', 20);



/*******************************************************************/
/*** Automatic Data-Purging                                      ***/

//completely enable/disable
@define('BO_PURGE_ENABLE', true);

//main interval in hours
@define('BO_PURGE_MAIN_INTVL', 6);

//optimizes table if deleted rows are bigger than value (0 disables)
@define('BO_PURGE_OPTIMIZE_TABLES', 0);

// min-age in hours, 0 disables
@define('BO_PURGE_SIG_NS', 24);     //signals with no strike assigned
@define('BO_PURGE_SIG_ALL', 192);   //all signals
@define('BO_PURGE_STR_NP', 0);      //strikes not participated
@define('BO_PURGE_STR_ALL', 0);     //all strikes
@define('BO_PURGE_STR_DIST', 0);    //strikes farther than BO_PURGE_STR_DIST_KM
@define('BO_PURGE_STRSTA_ALL', 24); //strike <-> stations table (very important!)
@define('BO_PURGE_STA_OTHER',  96); //station statistics: other (not yours)
@define('BO_PURGE_STA_ALL', 0);     //station statistics: all
@define('BO_PURGE_STR_DIST_KM', 2000); //distance for BO_PURGE_STR_DIST in kilometers




/*******************************************************************/
/*** Database Keys for strike table                              ***/
/*                                                                 */
/*   You should enable them if you want to make an archive         */
/*     -> faster search and drawing, but more disk-usage           */

//use partitioning
@define('BO_DB_PARTITIONING', false);

//use partitioning
@define('BO_DB_PARTITIONING_USE', false);

//create partitions for given months in advance
@define('BO_DB_PARTITION_MONTHS_INADVANCE', 8);

//number of subpartitions
@define('BO_DB_PARTITION_SUBPARTITIONS', 20);

//maximum number of partitions (only for creation!)
@define('BO_DB_PARTITION_MAX', 512);

//minimum rows of a range partition
//if two consecutive existing and old partitions have less rows, then they will be merged
@define('BO_DB_PARTITION_MIN_ROWS', 3000000);

//create a partition for each day group
@define('BO_DB_PARTITION_GROUP_DAYS', 0);

//divisor for longitude (stored as hash)
@define('BO_DB_PARTITION_LON_DIVISOR', 5);

//divisor for longitude (stored as hash)
@define('BO_DB_PARTITION_LAT_DIVISOR', 45);

//completely enable/disable
@define('BO_DB_EXTRA_KEYS', false);

//bytes for time-key (0 = disable)
@define('BO_DB_EXTRA_KEYS_TIME_BYTES', 2);

//time key starts at given date
@define('BO_DB_EXTRA_KEYS_TIME_START', '2011-01-01 00:00:00 UTC');

//divisor for time -> count value every x minutes
// -> 2bytes and 30min lasts for 3.7years
@define('BO_DB_EXTRA_KEYS_TIME_DIV_MINUTES', 30);

//bytes for each lat and lon key (0 = disable)
@define('BO_DB_EXTRA_KEYS_LATLON_BYTES', 1);

//key repeats every x degrees
// finer values -> higher resolution
// set to ~ "height" of your region
@define('BO_DB_EXTRA_KEYS_LAT_DIV', 30);

//divisor for longitude
// finer values -> higher resolution
// set to ~ "width" of your region
@define('BO_DB_EXTRA_KEYS_LON_DIV', 30);

//when requesting time periods, then round to full minutes (=60)
@define('BO_DB_TIME_ROUND_SECONDS', 60);

//calculate the maximum and minimum stroke id so it can be used instead of time for better index usage in database
@define('BO_DB_TIME2ID', true);

//cache the maximum and minimum stroke id from above
@define('BO_DB_TIME_CACHE', false);

//saves mercator coordinates into database
@define('BO_DB_STRIKES_MERCATOR', false);
@define('BO_DB_STRIKES_MERCATOR_SCALE', 20);

//log to file
@define('BO_DB_DEBUG_LOG', false);


/*******************************************************************/
/*** Strike alerts                                               ***/

//completely enable/disable
@define('BO_ALERTS', true);

//maximum search period for strikes
@define('BO_ALERT_MAX_SEARCH_PERIOD', 60);

//check every given minutes
@define('BO_ALERT_CHECK_INTERVAL', 15);

//after sending an alert, miniumum time to wait for next alert (minutes)
@define('BO_ALERT_SEND_INTERVAL', 45);




/*******************************************************************/
/*** E-Mail settings                                             ***/


//From header
//Example: "MyBlitzortung <mail@example.com>"
@define('BO_EMAIL_FROM', "");


//additional email headers
@define('BO_EMAIL_HEADERS', "");


//use SMTP
// You have to upload phpmailer-files into "includes/phpmailer"
// URL: http://code.google.com/a/apache-extras.org/p/phpmailer/
@define('BO_EMAIL_SMTP', false);

//SMTP settings
@define('BO_EMAIL_SMTP_SERVER', '');
@define('BO_EMAIL_SMTP_PORT',   25); //or use 587
@define('BO_EMAIL_SMTP_USERNAME', '');
@define('BO_EMAIL_SMTP_PASSWORD', '');
@define('BO_EMAIL_SMTP_SECURE', ''); // set to 'tls' or 'ssl' for secure connections



/*******************************************************************/
/*** SMS-Gateway URL                                             ***/
/*   Leave it blank, if you don't want to use that feature.                                                                      */
/*    - {text} will be replaced by the message text                                                                              */
/*    - {tel}  will be replaced by the telephone number                                                                          */
/*   Some examples. Of course you have to register yourself at the gateway provider and change USER/PASS to your values!         */
/*    - http://gateway.smstrade.de/?key=PASS&to={tel}&message={text}&from=MyBO&route=gold                                        */
/*    - http://gateway.sms77.de/?u=USER&p=PASS&to={tel}&text={text}&type=quality&from=MyBO                                       */
/*    - http://www.innosend.de/gateway/sms.php?id=USER&pw=PASS&absender=MyBO&empfaenger={tel}&text={text}&type=4                 */
@define('BO_SMS_GATEWAY_URL', ''); //do not edit here, put it in config.php file!!!


/*******************************************************************/
/*** Twitter settings                                            ***/

@define("BO_TWITTER_ENABLED",		false);
@define("BO_TWITTER_NAME", 			'');
@define("BO_TWITTER_API_KEY", 		'');
@define("BO_TWITTER_API_SECRET", 	'');
@define("BO_TWITTER_ACCESS_TOKEN", 	'');
@define("BO_TWITTER_ACCESS_SECRET",	'');



/*******************************************************************/
/*** Polarity on Dynamic map                                     ***/

/*** NOT WORKING! ***/

//size of the +/- symbol in strike on map
@define('BO_MAP_STRIKE_POLARITY_SIZE', 5);

//size of the circle symbol in strike on map if polarity is unknown
@define('BO_MAP_STRIKE_POLARITY_SIZE_UNKNOWN', 5);




/*******************************************************************/
/*** Graphs                                                      ***/
/*   You can change the appearance of almost ever graph            */
/*   individually (color, lines, size etc...)                      */

//nicer graphs, but no thick lines
@define('BO_GRAPH_ANTIALIAS', false);



/***********************/
/*** Raw Data Graphs ***/

//width, height
@define('BO_GRAPH_RAW_W', 300);
@define('BO_GRAPH_RAW_H', 150);

//spectrum settings
@define('BO_GRAPH_RAW_SPEC_WIDTH', 1);
@define('BO_GRAPH_RAW_SPEC_MAX_X', 160); //kHz
@define('BO_GRAPH_RAW_SPEC_MAX_Y', 10);

//width, height when displaying all graphs to a stroke
@define('BO_GRAPH_RAW_W2', 450);
@define('BO_GRAPH_RAW_H2', 160);

//width, height when displaying single big graph
@define('BO_GRAPH_RAW_W_BIG', 1000);
@define('BO_GRAPH_RAW_H_BIG', 500);

//width, height when displaying on statistics page
@define('BO_GRAPH_RAW_STATION_STATISTICS', false);
@define('BO_GRAPH_RAW_W_STAT', 600);
@define('BO_GRAPH_RAW_H_STAT', 300);
@define('BO_GRAPH_RAW_W_STAT_SPEC', 600);
@define('BO_GRAPH_RAW_H_STAT_SPEC', 150);


//max. time in s for displaying all graphs to a stroke
@define('BO_GRAPH_RAW_MAX_TIME2', 350);

//Colors
@define('BO_GRAPH_RAW_COLOR1', '#f00@0.2');
@define('BO_GRAPH_RAW_COLOR2', '#0f0@0.2');
@define('BO_GRAPH_RAW_COLOR3', '#ff0@0.2');
@define('BO_GRAPH_RAW_COLOR4', '#f0d@0.2');
@define('BO_GRAPH_RAW_COLOR5', '#0dd@0.2');
@define('BO_GRAPH_RAW_COLOR6', '#f80@0.2');
@define('BO_GRAPH_RAW_COLOR7', '#566aff@0.2');
@define('BO_GRAPH_RAW_COLOR8', '#56bfff@0.2');
@define('BO_GRAPH_RAW_COLOR_LINES', '#555@0.7');
@define('BO_GRAPH_RAW_COLOR_XY1', '#00f@0.6');
@define('BO_GRAPH_RAW_COLOR_XY2', '#f00@0.6');
@define('BO_GRAPH_RAW_COLOR_BOX', '#d0d0d0');
@define('BO_GRAPH_RAW_COLOR_BACK', '#fff');
@define('BO_GRAPH_RAW_COLOR_MARGIN','#fff');
@define('BO_GRAPH_RAW_COLOR_FRAME', '#fff');
@define('BO_GRAPH_RAW_COLOR_XGRID', '#eee');
@define('BO_GRAPH_RAW_COLOR_YGRID', '#eee');
@define('BO_GRAPH_RAW_COLOR_XAXIS', '#666');
@define('BO_GRAPH_RAW_COLOR_YAXIS', '#666');
@define('BO_GRAPH_RAW_COLOR_CAPTION', '#666');


@define('BO_GRAPH_RAW_COLOR_LINES_BIG', '#fff@0.7');
@define('BO_GRAPH_RAW_COLOR_BOX_BIG', '#333');
@define('BO_GRAPH_RAW_COLOR_BACK_BIG', '#000');
@define('BO_GRAPH_RAW_COLOR_MARGIN_BIG','#000');
@define('BO_GRAPH_RAW_COLOR_FRAME_BIG', '#000');
@define('BO_GRAPH_RAW_COLOR_XGRID_BIG', '#666');
@define('BO_GRAPH_RAW_COLOR_YGRID_BIG', '#666');
@define('BO_GRAPH_RAW_COLOR_XAXIS_BIG', '#ccc');
@define('BO_GRAPH_RAW_COLOR_YAXIS_BIG', '#ccc');
@define('BO_GRAPH_RAW_COLOR_CAPTION_BIG', '#ccc');

/************************/
/*** Statistics Graph ***/


/*** (main settings for all graphs) ***/

//time settings

// interval between each data point
@define('BO_GRAPH_STAT_STRIKES_ADV_GROUP_MINUTES',  30);

//default time reviews (hours)
@define('BO_GRAPH_STAT_HOURS_BACK', "24,6,12,48,72,96");

//max. review time for non-loggedin (hours)
@define('BO_GRAPH_STAT_HOURS_BACK_MAX', 96);

//default review time for station graph (days)
@define('BO_GRAPH_STAT_DAYS_BACK', "3,7,14,30");

//max. review time for station graph for non-loggedin (hours)
@define('BO_GRAPH_STAT_DAYS_BACK_MAX', 30);

//max. distance (km)
@define('BO_GRAPH_STAT_MAX_DISTANCE', 5000);
@define('BO_GRAPH_STAT_DISTANCE_LOG', false);

//main appearance
@define('BO_GRAPH_STAT_W', 550);
@define('BO_GRAPH_STAT_H', 300);
@define('BO_GRAPH_STAT_COLOR0', '#f00@0.5');
@define('BO_GRAPH_STAT_COLOR1', '#f00@0.5');
@define('BO_GRAPH_STAT_COLOR2', '#0f0@0.5');
@define('BO_GRAPH_STAT_COLOR3', '#800@0.6');
@define('BO_GRAPH_STAT_COLOR_BOX', '#d0d0d0');
@define('BO_GRAPH_STAT_COLOR_BACK', '#fff');
@define('BO_GRAPH_STAT_COLOR_CAPTION', '#666');
@define('BO_GRAPH_STAT_COLOR_CAPTION_BIG', '#ccc');
@define('BO_GRAPH_STAT_COLOR_MARGIN','#fff');
@define('BO_GRAPH_STAT_COLOR_FRAME', '#fff');
@define('BO_GRAPH_STAT_COLOR_XGRID', '#eee');
@define('BO_GRAPH_STAT_COLOR_YGRID', '#eee');
@define('BO_GRAPH_STAT_COLOR_XAXIS', '#666');
@define('BO_GRAPH_STAT_COLOR_YAXIS', '#666');
@define('BO_GRAPH_STAT_COLOR_XAXIS_TITLE', '#666');
@define('BO_GRAPH_STAT_COLOR_YAXIS_TITLE', '#666');
@define('BO_GRAPH_STAT_COLOR_LEGEND_FILL', '#fff@1');
@define('BO_GRAPH_STAT_COLOR_LEGEND_TEXT', '#666');
@define('BO_GRAPH_STAT_COLOR_LEGEND_FRAME', '#fff@1');
@define('BO_GRAPH_STAT_COLOR_TITLE', '#666');
@define('BO_GRAPH_STAT_FONTSIZE_TITLE', 8);
@define('BO_GRAPH_STAT_FONTSIZE_XAXIS', 7);
@define('BO_GRAPH_STAT_FONTSIZE_YAXIS', 7);


//Grouping of values by time for different time periods (hours)
@define('BO_GRAPH_STAT_GROUP_NONE',     7*24);
@define('BO_GRAPH_STAT_GROUP_HOURLY',  20*24);
@define('BO_GRAPH_STAT_GROUP_6HOURLY', 50*24);


/*** Statistics Graph (individual settings for each graph) ***/

//Statistics-Graph: Strikes (now)
@define('BO_GRAPH_STAT_STRIKES_NOW_COLOR_L1', '#55f@1');
@define('BO_GRAPH_STAT_STRIKES_NOW_COLOR_F1', '#ccf@0');
@define('BO_GRAPH_STAT_STRIKES_NOW_WIDTH_1',  1);
@define('BO_GRAPH_STAT_STRIKES_NOW_COLOR_L2', '#66f@1');
@define('BO_GRAPH_STAT_STRIKES_NOW_COLOR_F2', '#99f@0');
@define('BO_GRAPH_STAT_STRIKES_NOW_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STRIKES_NOW_GROUP_MINUTES',  15);

//Statistics-Graph: Strikes (Month, Year)
@define('BO_GRAPH_STAT_STRIKES_TIME_COLOR_L1', '#00f@1');
@define('BO_GRAPH_STAT_STRIKES_TIME_COLOR_F1', '#99f@0.2');
@define('BO_GRAPH_STAT_STRIKES_TIME_COLOR_L2', '#00f@1');
@define('BO_GRAPH_STAT_STRIKES_TIME_COLOR_F2', '#99f@0.6');
@define('BO_GRAPH_STAT_STRIKES_TIME_WIDTH', 0.5);

//Statistics-Graph: Strikes (Station)
@define('BO_GRAPH_STAT_STR_COLOR_L1', '#99f@1');
@define('BO_GRAPH_STAT_STR_COLOR_F1', '#ccf@0.2');
@define('BO_GRAPH_STAT_STR_WIDTH_1',  1);
@define('BO_GRAPH_STAT_STR_COLOR_L2', '#00f@1');
@define('BO_GRAPH_STAT_STR_COLOR_F2', '#99f@0.3');
@define('BO_GRAPH_STAT_STR_WIDTH_2',  2);
@define('BO_GRAPH_STAT_STR_COLOR_L3', '#00f@0.1');
@define('BO_GRAPH_STAT_STR_COLOR_F3', false);
@define('BO_GRAPH_STAT_STR_WIDTH_3',  1);

//Statistics-Graph: Signals
@define('BO_GRAPH_STAT_SIG_COLOR_L1', '#fa0@1');
@define('BO_GRAPH_STAT_SIG_COLOR_F1', '#fa0@0.8');
@define('BO_GRAPH_STAT_SIG_WIDTH_1',  1);
@define('BO_GRAPH_STAT_SIG_COLOR_L2', '#fc3@0.2');
@define('BO_GRAPH_STAT_SIG_COLOR_F2', false);
@define('BO_GRAPH_STAT_SIG_WIDTH_2',  2);

//Statistics-Graph: Distance
@define('BO_GRAPH_STAT_DIST_COLOR_L1', '#fa0@1');
@define('BO_GRAPH_STAT_DIST_COLOR_F1', '#397@0.8');
@define('BO_GRAPH_STAT_DIST_WIDTH_1',  1);
@define('BO_GRAPH_STAT_DIST_COLOR_L2', '#077@0.3');
@define('BO_GRAPH_STAT_DIST_COLOR_F2', false);
@define('BO_GRAPH_STAT_DIST_WIDTH_2',  2);

//Statistics-Graph: Ratio
@define('BO_GRAPH_STAT_RAT_COLOR_L1', '#fa0@0.9');
@define('BO_GRAPH_STAT_RAT_COLOR_F1', '#fa0@0.7');
@define('BO_GRAPH_STAT_RAT_WIDTH_1',  1);
@define('BO_GRAPH_STAT_RAT_COLOR_L2', '#fa0@0.5');
@define('BO_GRAPH_STAT_RAT_COLOR_F2', false);
@define('BO_GRAPH_STAT_RAT_WIDTH_2',  2);
@define('BO_GRAPH_STAT_RAT_COLOR_L3', '#88f@0.9');
@define('BO_GRAPH_STAT_RAT_COLOR_F3', '#88f@0.7');
@define('BO_GRAPH_STAT_RAT_WIDTH_3',  1);
@define('BO_GRAPH_STAT_RAT_COLOR_L4', '#00f@0.5');
@define('BO_GRAPH_STAT_RAT_COLOR_F4', false);
@define('BO_GRAPH_STAT_RAT_WIDTH_4',  2);

//Statistics-Graph: Stations
@define('BO_GRAPH_STAT_STA_COLOR_L1', '#c00@0.98');
@define('BO_GRAPH_STAT_STA_COLOR_F1', '#c00@0.85');
@define('BO_GRAPH_STAT_STA_WIDTH_1',  1);
@define('BO_GRAPH_STAT_STA_COLOR_L2', '#fa0@0.1');
@define('BO_GRAPH_STAT_STA_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STA_COLOR_L3', '#0cc@0.90');
@define('BO_GRAPH_STAT_STA_COLOR_F3', '#0cc@0.85');
@define('BO_GRAPH_STAT_STA_WIDTH_3',  1);
@define('BO_GRAPH_STAT_STA_COLOR_L4', '#0ac@0.1');
@define('BO_GRAPH_STAT_STA_WIDTH_4',  1);

//Statistics-Graph: Distance-Ratio
@define('BO_GRAPH_STAT_RATIO_DIST_DIV', 20);
@define('BO_GRAPH_STAT_RATIO_DIST_LINE', false);
@define('BO_GRAPH_STAT_RATIO_DIST_COLOR_L1', '#00f@1');
@define('BO_GRAPH_STAT_RATIO_DIST_COLOR_F1', '#ada@0.2');
@define('BO_GRAPH_STAT_RATIO_DIST_WIDTH1',  1.2);
@define('BO_GRAPH_STAT_RATIO_DIST_COLOR_L2', '#22f@0.8');
@define('BO_GRAPH_STAT_RATIO_DIST_COLOR_F2', '#22f@0.95');
@define('BO_GRAPH_STAT_RATIO_DIST_WIDTH2',  1);

//Statistics-Graph: Bearing-Ratio
@define('BO_GRAPH_STAT_RATIO_BEAR_DIV', 5);
@define('BO_GRAPH_STAT_RATIO_BEAR_LINE', false);
@define('BO_GRAPH_STAT_RATIO_BEAR_COLOR_L1', '#00f@1');
@define('BO_GRAPH_STAT_RATIO_BEAR_COLOR_F1', '#ada@0.2');
@define('BO_GRAPH_STAT_RATIO_BEAR_WIDTH1',  1.2);
@define('BO_GRAPH_STAT_RATIO_BEAR_COLOR_L2', '#22f@0.8');
@define('BO_GRAPH_STAT_RATIO_BEAR_COLOR_F2', '#22f@0.95');
@define('BO_GRAPH_STAT_RATIO_BEAR_WIDTH2',  1);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE',  true);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_SIZE',  550);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_COLOR_BACKGROUND', 'fff');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_COLOR1', 'cec');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_COLOR2', '99f');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_COUNT_WIDTH',  3);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_ANTENNA_WIDTH',  2);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_ANTENNA1_COLOR', 'f00');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_ANTENNA2_COLOR', '0d0');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_TITLE_SIZE', 0.45);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_TITLE_COLOR', '000');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_NUMBERS_SIZE', 0.4);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_NUMBERS_COLOR1', '060');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_NUMBERS_COLOR2', '00f');
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_NUMBERS_ANGLE1', 30);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_NUMBERS_ANGLE2', 200);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_FONTSIZE_BEAR', 0.7);
@define('BO_GRAPH_STAT_RATIO_BEAR_WINDROSE_FONTSIZE_OTHER', 0.4);

//Statistics-Graph: Strikes by no. of participants
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_L1', '#00f@1');
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_F1', '#66f@0');
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_L2', '#00f@1');
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_F2', '#aaf@0');
@define('BO_GRAPH_STAT_PARTICIPANTS_WIDTH', 2);
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_L3', '#c0f@0.6');
@define('BO_GRAPH_STAT_PARTICIPANTS_COLOR_F3', false);
@define('BO_GRAPH_STAT_PARTICIPANTS_WIDTH2',  1);
@define('BO_GRAPH_STAT_PARTICIPANTS_LOG', true);

//Statistics-Graph: Strikes with specific participants
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_L1', '#d00@0.4');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_F1', false);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_WIDTH_1',  1);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_L2', '#f66@0.4');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_F2', false);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_L3', '#00f@0.9');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_COLOR_F3', '#55f@0.9');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_WIDTH_3',  0);

//Statistics-Graph: Strikes with participants
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_L1', '#f00@0.4');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_F1', false);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_WIDTH_1',  2);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_L2', '#f60@0.4');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_F2', false);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_L3', '#00f@0.9');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_COLOR_F3', '#55f@0.9');
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_WIDTH_3',  0);
@define('BO_GRAPH_STAT_STRIKES_PARTICIPANTS_AVG_GROUP_MINUTES',  15);

//Statistics-Graph: Strikes by deviations
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_L1', '#00f@1');
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_F1', '#66f@0');
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_L2', '#00f@1');
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_F2', '#aaf@0.4');
@define('BO_GRAPH_STAT_DEVIATIONS_WIDTH', 2);
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_L3', '#c0f@0');
@define('BO_GRAPH_STAT_DEVIATIONS_COLOR_F3', false);
@define('BO_GRAPH_STAT_DEVIATIONS_WIDTH2',  1);
@define('BO_GRAPH_STAT_DEVIATIONS_LOG', false);

//Statistics-Graph: Strikes with specific deviations
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_L1', '#d00@0.4');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_F1', false);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_WIDTH_1',  1);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_L2', '#f66@0.4');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_F2', false);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_L3', '#00f@0.9');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_COLOR_F3', '#55f@0.9');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_WIDTH_3',  0);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_GROUP_MINUTES',  15);

//Statistics-Graph: Strikes with average deviations
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_L1', '#f00@0.4');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_F1', false);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_WIDTH_1',  2);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_L2', '#f60@0.4');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_F2', false);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_WIDTH_2',  1);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_L3', '#00f@0.9');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_COLOR_F3', '#55f@0.9');
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_WIDTH_3',  0);
@define('BO_GRAPH_STAT_STRIKES_DEVIATIONS_AVG_GROUP_MINUTES',  15);

//Statistics-Graph: Evaluated Signals
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_L1', '#fa0@0.3');
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_F1', false);
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_WIDTH_1', 2);
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_L2', '#f0f@0.3');
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_F2', false);
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_WIDTH_2', 1);
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_L3', '#0a0@1');
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_COLOR_F3', '#33f@0.9');
@define('BO_GRAPH_STAT_EVALUATED_SIGNALS_WIDTH_3',  1);

//Statistics-Graph: Spectrums
@define('BO_GRAPH_STAT_SPECTRUM_COLOR1', '#f55@0.5');
@define('BO_GRAPH_STAT_SPECTRUM_COLOR2', '#5f5@0.5');
@define('BO_GRAPH_STAT_SPECTRUM_WIDTH1', 2);
@define('BO_GRAPH_STAT_SPECTRUM_WIDTH2', 0.6);
@define('BO_GRAPH_STAT_SPECTRUM_COLOR3', '#c00@0.3');
@define('BO_GRAPH_STAT_SPECTRUM_WIDTH3', 2);
@define('BO_GRAPH_STAT_SPECTRUM_COLOR4', '#0c0@0.3');
@define('BO_GRAPH_STAT_SPECTRUM_WIDTH4', 2);

//Statistics-Graph: Empl/Freq by time
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_L1A', '#e22@0.5');
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_F1A', false);
@define('BO_GRAPH_STAT_SIGNALS_TIME_WIDTH_1A', 2);
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_L2A', '#2f2@0.5');
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_F2A', false);
@define('BO_GRAPH_STAT_SIGNALS_TIME_WIDTH_2A', 2);
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_L1B', '#f99@0.9');
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_F1B', '#f55@0.8');
@define('BO_GRAPH_STAT_SIGNALS_TIME_WIDTH_1B', 1);
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_L2B', '#9f9@0.9');
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_F2B', '#5f5@0.8');
@define('BO_GRAPH_STAT_SIGNALS_TIME_WIDTH_2B', 1);
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_L3', '#f0f@0.9');
@define('BO_GRAPH_STAT_SIGNALS_TIME_COLOR_F3', '#f0f@0.95');
@define('BO_GRAPH_STAT_SIGNALS_TIME_WIDTH_3', 1);





/*******************************************************************/
/*** Some special/expert settings                                ***/
/*** You shouldn't change them unless you know what you're doing ***/

//Default socket timeout
@define('BO_SOCKET_TIMEOUT', 40);

//set max time in pictures to age of latest calculated strike
//if within given minutes from now
@define('BO_LATEST_STRIKE_TIME_CALC', 8);

// Fuzzy strike update to avoid duplicates
@define('BO_UP_STRIKES_FUZZY_NSEC', 400000);
@define('BO_UP_STRIKES_FUZZY_KM',   50);

// Timeouts (Seconds)
// If you your station sends a lot of signals or strike rate is very high
// and not all strikes are displayed set BO_UP_MAX_TIME higher (i.e 120)
// and lower BO_UP_MAX_SLEEP (i.e. 5).
@define('BO_UP_MAX_TIME',  55); // max. exec time
@define('BO_UP_MAX_SLEEP', 30); // max. sleep time in seconds before importing

// set to true, if you want to use "file_get_contents"
// you wouldn't be able to use partial downloads with setting "true"!
@define('BO_USE_PHPURLWRAPPER', false);

//enable longtime statistics for all stations
//causes a LOT OF more load during importing
@define('BO_ENABLE_LONGTIME_ALL', false);

//don't use your station as default station
//you may set the following settings
//  BO_LAT/BO_LON to a custom location
//  BO_ENABLE_LONGTIME_ALL -> true
//  BO_MAX_ZOOM_IN -> 8
//  BO_RADIUS -> 0
@define('BO_NO_DEFAULT_STATION', false);

//if you want to show more than one station, then you can enter 
//a comma separated list here, i.e. '1,2,3'
@define('BO_SHOW_STATIONS', '');

//argument that specifies language
@define('BO_LANG_ARGUMENT', 'bo_lang');

//max length of query string (currently only for bulk inserts)
@define('BO_DB_MAX_QUERY_LEN', 50000);

//low priority updates for some update queries
@define('BO_DB_UPDATE_LOW_PRIORITY', false);

//compression for the "conf" table (mainly used for statistics)
//can speed up import of data
//note: immediately after enabling this setting, login to user area as admin
//a update is needed! 
@define('BO_DB_COMPRESSION', false);

//load image from cache (if exists) on very high loads, independently of age
define('BO_LOADAVG_USE_CACHE', 120);

//send not-modified for tiles or station tiles on high loads
define('BO_LOADAVG_TILES', 120);
define('BO_LOADAVG_TILES_STATIONS', 70);


/*******************************************************************/
/*** Some special settings which shouldn't be changed            ***/

//Import server settings
@define("BO_IMPORT_SERVER", 'data.blitzortung.org');
@define("BO_IMPORT_PATH", 'Data_%d/Protected/');
@define("BO_IMPORT_PATH_STROKES", 'Strokes');
@define("BO_IMPORT_PATH_STATIONS", 'stations.txt.gz');

//Special server for signals
@define("BO_IMPORT_SERVER_SIGNALS", 'signals.blitzortung.org');
@define("BO_IMPORT_PATH_SIGNALS", 'Data_%d/');


//Tile dimensions (pixels)
@define("BO_TILE_SIZE", 512);

//Tile dimensions for strike counter
@define("BO_TILE_SIZE_COUNT", 512);

//timeout for tile creating
@define("BO_TILE_CREATION_TIMEOUT", 5);

//multiplicator for tile interval
@define("BO_TILE_UPDATE_MULTI", 1);

//subtract minutes from tile time
@define("BO_TILE_UPDATE_SUB", 3);

//max. age of last strike update until strikes will be shown as "old"
@define('BO_TILE_MAX_AGE_STRIKES_MINUTES', 10);

//Min and max count of participants - values are only used if
//automatic getting from participants.txt failed
@define('BO_MIN_PARTICIPANTS', 6);
@define('BO_MAX_PARTICIPANTS', 12);

//max. signal level
@define('BO_MAX_VOLTAGE', 2.5);
@define('BO_MAX_VOLTAGE_RED', 1.5);

//trigger voltage
@define('BO_TRIGGER_VOLTAGE', 0.45);

//search interval for strike -> signal matching for foreign stations
@define('BO_STR2SIG_INTERVAL_OTHERS', 8000); //s

//needed for auto linking stations
@define('BO_LINK_HOST', 'www.myblitzortung.org');
@define('BO_LINK_URL',  '/blitzortung/bo.php');

//for finding signal to strike
@define('BO_STR2SIG_C', 299792458); //speed of light
@define('BO_STR2SIG_FUZZ_SEC', 0.00001); //minimum fuzzy-seconds
@define('BO_STR2SIG_FUZZ_SECM', 0.0001); //fuzzy-seconds per meter
@define('BO_STR2SIG_FUZZ_OFFSET', 0); //fuzzy offset
@define('BO_STR2SIG_TRIGGER_FACTOR', 0.9); //factor for BO_TRIGGER_VOLTAGE

//speed of light for runtime in archive table (and perhaps other display)
@define('BO_C', 299792458); // Blitzortung.org uses c/1.000198

//finding no of min participants / no of max. participants for calculation
@define('BO_FIND_MIN_PARTICIPANTS_HOURS', 2); //update and search intervall for min participants
@define('BO_FIND_MIN_PARTICIPANTS_COUNT', 4); //how often a new value has to be present to be saved
@define('BO_FIND_MAX_PARTICIPANTS_HOURS', 24); //update and search intervall for max participants

//when station deleted -> assign a new unique id from defined value and up (MySQL UNSIGNED SMALLINT!)
@define('BO_DELETED_STATION_MIN_ID', 50000);

//delete station from database if it isn't in stations.txt any more last_data was more than given days before
@define('BO_DELETE_STATION_DAYS', 7);

//draws nicer circles
//0: off
//1: on
//2: auto-fallback to old method (off) in some cases, due to bug in old php versions
@define('BO_NICE_CIRCLES', 2);


/*******************************************************************/
/*** Settings for Developers                                     ***/

@define('BO_DEBUG', false); //enables PHP error reporting
@define('BO_LANG_AUTO_ADD', false); //automatically adds missing translations to the locale file if it is writeable



?>